// procura pelo valor do token dentro dos cookies
var getSessionCookie = function () {
    let name = "token=";

    // document.cookie contem encoded components - ?,=,&,/ etc
    let decodedCookie = decodeURIComponent(document.cookie);
    let ca = decodedCookie.split(';');

    // procura pelo valor do cookie 'token'
    for(let i = 0; i <ca.length; i++) {
        let c = ca[i];
        // salta espaços no início, pode ter a ver com compatibilidade entre navegadores
        // TO-DO: verificar se é mesmo necessário
        while (c.charAt(0) == ' ') { 
            c = c.substring(1);
        }
        if (c.indexOf(name) == 0) {
            return c.substring(name.length, c.length);
        }
    }
    return false;
}

var setSessionCookie = function (token) {
    document.cookie = "token=" + token;
}

$(function () {
    var user_panel_visible = false;
    $("#bbx-user-button").click(function (event) {
        if (user_panel_visible) {
            $("#bbx-user-panel").animate({right: '-300px'});
        } else {
            $("#bbx-user-panel").animate({right: '0px'});
        }
        user_panel_visible = !user_panel_visible;
    })
    $page.onChange('session', function (event) {
        if ($page.session) {
            $("#bbx-profile-name").text($page.session.mocambola.name);
            $("#bbx-user-inner-panel").animate({'margin-left': '-300px'});
            setSessionCookie($page.session.token);
        } else {
            $("#bbx-user-inner-panel").animate({'margin-left': '0'});
            $("#bbx-profile-name").text('');
            setSessionCookie('');
        }
    });
    $("#bbx-login-form").submit(function (event) {
        event.preventDefault();
        $page.postAuth($("#bbx-login-username").val(), $("#bbx-login-password").val());
    });
    $("#bbx-profile-logout").click(function (event) {
        // TODO Logout stuf
        $page.session = false;
    });

    // disparado ao carregar e ao recarregar a pagina
    if (getSessionCookie()) {
        $page.loadSession(getSessionCookie());
    }
});